Index: trunk/kernel/drivers/soclib/soclib_dma.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_dma.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_dma.c	(revision 1)
@@ -0,0 +1,377 @@
+/*
+ * soclib_dma.c - soclib DMA driver
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <errno.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+#include <drvdb.h>
+#include <kmem.h>
+#include <scheduler.h>
+#include <thread.h>
+#include <task.h>
+#include <list.h>
+#include <event.h>
+#include <soclib_dma.h>
+#include <string.h>
+
+/* DMA mapped registers offset */
+#define DMA_SRC_REG          0
+#define DMA_DST_REG          1
+#define DMA_LEN_REG          2
+#define DMA_RESET_REG        3
+#define DMA_IRQ_DISABLED     4
+
+struct dma_context_s
+{
+	struct list_entry request_queue;
+	struct wait_queue_s pending;
+};
+
+static void dma_start_request(struct device_s *dma, dev_request_t *ptr)
+{
+	volatile uint32_t *base = dma->base;
+	dev_request_t *rq;
+
+	rq = (ptr->flags & DEV_RQ_NESTED) ? ptr->data : ptr;
+
+	base[DMA_SRC_REG]      = (unsigned int)rq->src;
+	base[DMA_DST_REG]      = (unsigned int)rq->dst;
+	base[DMA_IRQ_DISABLED] = 0;
+	base[DMA_LEN_REG]      = rq->count;
+}
+
+static void dma_irq_handler(struct irq_action_s *action)
+{
+	struct dma_context_s *ctx;
+	struct device_s *dma;
+	dev_request_t *rq;
+	dev_request_t *frag;
+	dev_request_t *new_rq;
+	error_t err;
+	volatile uint32_t *base;
+	struct thread_s *this;
+
+	dma  = action->dev;
+	base = dma->base;
+	ctx  = (struct dma_context_s*)dma->data;
+
+	cpu_spinlock_lock(&dma->lock.val);
+  
+	err = base[DMA_LEN_REG];
+	base[DMA_RESET_REG] = 0;
+
+	/* even if this case is realy low probable, we have to check for empty list ! */
+	if(list_empty(&ctx->request_queue))
+	{
+		cpu_spinlock_unlock(&dma->lock.val);
+		return;
+	}
+
+	rq = list_first(&ctx->request_queue, dev_request_t, list);
+
+	if(rq->flags & DEV_RQ_NESTED)
+	{
+		frag = rq->data;
+
+		event_set_error(&frag->event, err);
+		event_set_senderId(&frag->event, dma);
+		event_send(&frag->event, current_cpu->gid);
+
+		if((err == 0) && (frag->data != NULL))
+		{
+			rq->data = frag->data;
+			dma_start_request(dma,frag->data);
+			cpu_spinlock_unlock(&dma->lock.val);
+			return;
+		}
+	}
+
+	list_unlink(&rq->list);
+  
+	if(!(list_empty(&ctx->request_queue)))
+	{
+		new_rq = list_first(&ctx->request_queue, dev_request_t, list);
+		dma_start_request(dma,new_rq);
+	}
+  
+	if(!(rq->flags & DEV_RQ_NOBLOCK))
+	{
+		rq->err = err;
+		wakeup_one(&ctx->pending, WAIT_FIRST);
+		cpu_spinlock_unlock(&dma->lock.val);
+		return;
+	}
+  
+	cpu_spinlock_unlock(&dma->lock.val);
+
+	this = CURRENT_THREAD;
+ 
+	event_set_error(&rq->event, err);
+	event_set_senderId(&rq->event, dma);
+	event_send(&rq->event, current_cpu->gid);
+}
+
+static void dma_fraglist_destroy(dev_request_t *ptr)
+{
+	kmem_req_t req;
+	dev_request_t *frag;
+
+	req.type = KMEM_DMA_REQUEST;
+	frag     = ptr;
+
+	while(frag != NULL);
+	{
+		req.ptr = frag;
+		frag    = frag->data;
+
+		kmem_free(&req);
+	}
+}
+
+static EVENT_HANDLER(dma_async_frag_event)
+{
+	dev_request_t *frag;
+	kmem_req_t req;
+	error_t err;
+
+	frag = event_get_argument(event);
+	err  = event_get_error(event);
+
+	assert(frag != NULL && "corrupted frag");
+
+	if(err)
+	{
+		dma_fraglist_destroy(frag);
+		return 0;
+	}
+
+	req.type = KMEM_DMA_REQUEST;
+	req.ptr  = frag;
+
+	kmem_free(&req);
+	return 0;
+}
+
+static error_t dma_frag_init(dev_request_t *frag, uint_t src_start, uint_t dst_start, uint_t count)
+{
+	//FIXME(40) use extent registers
+	frag->src   = task_vaddr2paddr(current_task, (void*)src_start);
+	frag->dst   = task_vaddr2paddr(current_task, (void*)dst_start);
+	frag->count = count;
+	frag->flags = 0;
+
+	if((frag->src == NULL) || (frag->dst == NULL))
+		return EPERM;
+
+	event_set_priority(&frag->event, E_FUNC);
+	event_set_handler(&frag->event, &dma_async_frag_event);
+	event_set_argument(&frag->event, frag);
+	return 0;
+}
+
+static error_t dma_fraglist_build(dev_request_t *rq)
+{
+	kmem_req_t req;
+	dev_request_t *frag;
+	dev_request_t *parent_frag;
+	struct slist_entry *root;
+	struct slist_entry *iter;
+	uint_t src_start;
+	uint_t dst_start;
+	uint_t count;
+	error_t err;
+
+	if(rq->count == 0)
+		return EINVAL;
+
+	src_start = (uint_t)rq->src;
+	dst_start = (uint_t)rq->dst;
+
+	if((src_start + rq->count) <= ((src_start & ~PMM_PAGE_MASK) + PMM_PAGE_SIZE) &&
+	   (dst_start + rq->count) <= ((dst_start & ~PMM_PAGE_MASK) + PMM_PAGE_SIZE))
+	{
+		//FIXME(40) use extent registers
+		rq->src = task_vaddr2paddr(current_task, rq->src);
+		rq->dst = task_vaddr2paddr(current_task, rq->dst);
+
+		if((rq->src == NULL) || (rq->dst == NULL))
+			return EPERM;
+
+		return 0;
+	}
+
+	if((src_start & PMM_PAGE_MASK) || (dst_start & PMM_PAGE_MASK)) {
+		return ENOSYS;
+	}
+
+	req.type    = KMEM_DMA_REQUEST;
+	req.size    = sizeof(*rq);
+	req.flags   = AF_KERNEL;
+	root        = (struct slist_entry *)&rq->data;
+	iter        = (struct slist_entry *)&rq->list;
+	count       = rq->count;
+	rq->data    = NULL;
+	rq->flags  &= ~DEV_RQ_NESTED;
+	parent_frag = rq;
+
+	while(count)
+	{
+		frag = kmem_alloc(&req);
+
+		if(frag == NULL)
+		{
+			err = ENOMEM;
+			goto fail_nomem;
+		}
+
+		if(count >= PMM_PAGE_SIZE)
+		{
+			err = dma_frag_init(frag, src_start, dst_start, PMM_PAGE_SIZE);
+
+			if(err)
+				goto fail_init;
+
+			src_start += PMM_PAGE_SIZE;
+			dst_start += PMM_PAGE_SIZE;
+			count     -= PMM_PAGE_SIZE;
+		}
+		else
+		{
+			err = dma_frag_init(frag, src_start, dst_start, count);
+
+			if(err)
+				goto fail_init;
+
+			count -= count;
+		}
+
+		parent_frag->data = frag;
+		frag->data        = NULL;
+		parent_frag       = frag;
+	}
+
+	rq->flags |= DEV_RQ_NESTED;
+	return 0;
+
+fail_init:
+fail_nomem:
+	dma_fraglist_destroy(rq->data);
+	return err;
+}
+
+
+static sint_t dma_request(struct device_s *dma, dev_request_t *rq)
+{
+	struct dma_context_s *ctx;
+	uint_t irq_state;
+	sint_t err;
+
+	rq->err = 0;
+	ctx     = (struct dma_context_s*)dma->data;
+
+	err = dma_fraglist_build(rq);
+
+	if(err)
+		return err;
+
+	spinlock_lock_noirq(&dma->lock,&irq_state);
+
+	if(list_empty(&ctx->request_queue))
+	{
+		list_add(&ctx->request_queue, &rq->list);
+		dma_start_request(dma, rq);
+	}
+	else
+		list_add_last(&ctx->request_queue, &rq->list);
+
+	if(rq->flags & DEV_RQ_NOBLOCK)
+	{
+		spinlock_unlock_noirq(&dma->lock, irq_state);
+		return 0;
+	}
+
+	wait_on(&ctx->pending, WAIT_LAST);
+	spinlock_unlock_noirq(&dma->lock,irq_state);
+	sched_sleep(CURRENT_THREAD);
+
+	return rq->err;
+}
+
+static sint_t dma_open(struct device_s *dma, dev_request_t *rq)
+{
+	return EPERM;
+}
+
+struct device_s *__sys_dma;
+static uint_t dma_count = 0;
+
+error_t soclib_dma_init(struct device_s *dma)
+{
+	kmem_req_t req;
+	struct dma_context_s *ctx;
+
+	spinlock_init(&dma->lock,"DevDMA (SoCLib)");
+	dma->type = DEV_BLK;
+
+	dma->action.dev         = dma;
+	dma->action.irq_handler = &dma_irq_handler;
+	dma->action.data        = NULL;
+
+	if(dma_count == 0)
+		__sys_dma = dma;
+
+	sprintk(dma->name, 
+#if CONFIG_ROOTFS_IS_VFAT
+		"DMA%d"
+#else
+		"dma%d"
+#endif
+		,dma_count++);
+
+	metafs_init(&dma->node, dma->name);
+  
+	dma->op.dev.open       = &dma_open;
+	dma->op.dev.read       = &dma_request;
+	dma->op.dev.write      = &dma_request;
+	dma->op.dev.close      = NULL;
+	dma->op.dev.lseek      = NULL;
+	dma->op.dev.mmap       = NULL;
+	dma->op.dev.munmap     = NULL;
+	dma->op.dev.set_params = NULL;
+	dma->op.dev.get_params = NULL;
+	dma->op.drvid          = SOCLIB_DMA_ID;
+
+	req.type  = KMEM_GENERIC;
+	req.size  = sizeof(*ctx);
+	req.flags = AF_BOOT | AF_ZERO;
+  
+	if((ctx = kmem_alloc(&req)) == NULL)
+		return ENOMEM;
+
+	wait_queue_init(&ctx->pending, dma->name);
+	list_root_init(&ctx->request_queue);
+	dma->data = (void *)ctx;
+	return 0;
+}
+
+driver_t soclib_dma_driver = { .init = &soclib_dma_init };
Index: trunk/kernel/drivers/soclib/soclib_dma.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_dma.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_dma.h	(revision 1)
@@ -0,0 +1,28 @@
+/*
+ * soclib_dma.c - soclib DMA driver
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_DMA_H_
+#define _SOCLIB_DMA_H_
+
+extern struct driver_s soclib_dma_driver;
+
+#endif	/* _SOCLIB_DMA_H_ */
Index: trunk/kernel/drivers/soclib/soclib_fbf.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_fbf.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_fbf.c	(revision 1)
@@ -0,0 +1,23 @@
+/*
+ * soclib_fbf.c - soclib frame-buffer driver implementation.
+ *
+ * Author Alain greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH..
+ *
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
Index: trunk/kernel/drivers/soclib/soclib_fbf.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_fbf.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_fbf.h	(revision 1)
@@ -0,0 +1,28 @@
+/*
+ * soclib_fbf.h - soclib frame-buffer driver definition.
+ *
+ * Author Alain greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_FB_H_
+#define _SOCLIB_FB_H_
+
+
+#endif
Index: trunk/kernel/drivers/soclib/soclib_hba.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_hba.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_hba.c	(revision 1)
@@ -0,0 +1,277 @@
+/*
+ * soclib_hba.c - soclib AHCI block device driver implementation.
+ *
+ * Author     Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH..
+ *
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <printk.h>
+#include <hal_special.h>
+#include <device.h>
+#include <dev_ioc.h>
+#include <soclib_hba.h>
+#include <spinlock.h>
+#include <thread.h>
+
+//////////////////////////////////////////////////////////////////////////////////
+//   SOCLIB_HBA specific global variables
+//////////////////////////////////////////////////////////////////////////////////
+	
+// command list : up to 32 commands
+__attribute__((section(".kdata")))
+hba_cmd_desc_t     hba_cmd_list[32] __attribute__((aligned(0x40)));   
+
+// command tables array : one command table per entry in command list
+__attribute__((section(".kdata")))
+hba_cmd_table_t    hba_cmd_table[32] __attribute__((aligned(0x40))); 
+
+// extended pointer on the owner thread, for each slot
+__attribute__((section(".kdata")))
+xptr_t             hba_owner_thread[32];
+
+// bit vector of active slots
+__attribute__((section(".kdata")))
+uint32_t           hba_active_slots; 
+
+// spinlock protecting the command slot allocator
+__attribute__((section(".kdata")))
+spinlock_t         hba_lock;
+
+/////////////////////////////////////
+void soclib_hba_init( xptr_t dev_xp )
+{
+    // get IOC device descriptor cluster and local pointer 
+    cxy_t      dev_cxy  = GET_CXY( dev_xp );
+    device_t * dev_ptr  = (device_t *)GET_PTR( dev_xp );
+  
+    // get hardware device base address
+	xptr_t     hba_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get hardware device cluster and local pointer
+    cxy_t      hba_cxy  = GET_CXY( hba_xp );
+    uint32_t * hba_ptr  = (uint32_t *)GET_PTR( hba_xp );
+
+    // get block_size and block_count  
+	uint32_t block_size  = hal_remote_lw( XPTR( hba_cxy , hba_ptr + HBA_BLOCK_SIZE_REG ) );
+	uint32_t block_count = hal_remote_lw( XPTR( hba_cxy , hba_ptr + HBA_BLOCK_COUNT_REG ) );
+
+    // set device descriptor extension
+    hal_remote_sw( XPTR( dev_cxy , &dev_ptr->ext.ioc.size  ) , block_size );
+    hal_remote_sw( XPTR( dev_cxy , &dev_ptr->ext.ioc.count ) , block_count );
+
+	// reset SOCLIB_HBA driver global variables
+    hba_active_slots = 0;
+
+} // end soclib_hba_init()
+
+
+//////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_hba_command( xptr_t th_xp )
+{
+
+    uint32_t           to_mem;       // to_mem : command argument
+    uint32_t           lba;          // lba    : command argument
+    uint32_t           count;        // count  : command argument
+    xptr_t             buf_xp;       // buffer : command argument
+    xptr_t             dev_xp;       // device : command argument
+    uint32_t           cmd_id;       // current slot index in command bit_vector
+    hba_cmd_desc_t   * cmd_desc;     // command descriptor pointer   
+    hba_cmd_table_t  * cmd_table;    // command table pointer
+    bool_t             found;
+    uint32_t           iter; 
+
+    // get client thread cluster and local pointer
+    cxy_t      th_cxy = GET_CXY( th_xp );
+    thread_t * th_ptr = (thread_t *)GET_PTR( th_xp );
+
+    // get command arguments and extended pointer on IOC device
+    to_mem    =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.ioc.to_mem ) );
+    lba       =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.ioc.lba    ) );
+    count     =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.ioc.count  ) );
+    buf_xp    = (xptr_t)hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.ioc.buf_xp ) );
+    dev_xp    = (xptr_t)hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.ioc.dev_xp ) );
+
+    // get IOC device cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get extended pointer on SOCLIB-HBA peripheral
+    xptr_t     hba_xp = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get SOCLIB_HBA device cluster and local pointer
+    cxy_t      hba_cxy = GET_CXY( hba_xp );
+    uint32_t * hba_ptr = (uint32_t *)GET_PTR( hba_xp );
+
+    // try to register the I/O operation in a free slot 
+    // returns if success, deschedule if no slot available
+    // we do not need a lock to access the slot allocator,
+    // because the driver is only called by the server thread.
+    while( 1 )
+    {
+        // try to find a free slot in the 32 slots command list
+        cmd_id = 0;
+        found  = false;
+        for ( iter = 0 ; iter < 32 ; iter++ )
+        {
+            if( (hba_active_slots & (1<<iter) ) == 0 )
+            {
+                found  = true;
+                cmd_id = iter;
+                hba_active_slots |= (1<<iter);
+                break;
+            }
+        }
+
+        if( found )  // register and starts the I/O operation
+        {
+            // compute pointers on command descriptor and command table    
+            cmd_desc  = &hba_cmd_list[cmd_id];
+            cmd_table = &hba_cmd_table[cmd_id];
+
+            // set  buffer descriptor in command table 
+            cmd_table->buffer.dba  = (uint32_t)(buf_xp);   
+            cmd_table->buffer.dbau = (uint32_t)(buf_xp >> 32);
+            cmd_table->buffer.dbc  = count * 512;
+
+            // initialize command table header
+            cmd_table->header.lba0 = (char)lba;
+            cmd_table->header.lba1 = (char)(lba>>8);
+            cmd_table->header.lba2 = (char)(lba>>16);
+            cmd_table->header.lba3 = (char)(lba>>24);
+            cmd_table->header.lba4 = 0;
+            cmd_table->header.lba5 = 0;
+
+            // initialise command descriptor
+            cmd_desc->prdtl[0] = 1;
+            cmd_desc->prdtl[1] = 0;
+            if( to_mem ) cmd_desc->flag[0] = 0x00;
+            else         cmd_desc->flag[0] = 0x40;     
+
+#if USE_IOB // software L2/L3 cache coherence 
+
+            // compute physical addresses 
+            paddr_t   cmd_desc_paddr;    // command descriptor physical address
+            paddr_t   cmd_table_paddr;   // command table header physical address
+            bool_t    ident = CONFIG_KERNEL_IDENTITY;
+            
+            error = vmm_v2p_translate( ident , cmd_table , &cmd_table_paddr );
+            if( error )
+            {
+                printk("\n[PANIC] in %s : cannot get paddr fo cmd_table\n", __FUNCTION__ );
+                hal_core_sleep()
+            }
+
+            error = vmm_v2p_translate( ident , cmd_desc , &cmd_desc_paddr );
+            if( error )
+            {
+                printk("\n[PANIC] in %s : cannot get paddr fo cmd_desc\n", __FUNCTION__ );
+                hal_core_sleep()
+            }
+
+            // update L3 for command table 
+            dev_mmc_sync( cmd_table_paddr , sizeof(hba_cmd_table_t) );
+
+            // update L3 for command descriptor
+            dev_mmc_sync( cmd_desc_paddr , sizeof(hba_cmd_desc_t) );
+
+#endif // end software L2/L3 cache coherence
+
+            // activates HBA interrupts 
+            hal_remote_sw( XPTR( hba_cxy , hba_ptr + HBA_PXIE_REG ) , 0x1 );
+
+            // set hba_owner_thread[slot] 
+            hba_owner_thread[cmd_id] = th_xp;
+
+            // set HBA_PXCI_REG to start transfer
+            hal_remote_sw( XPTR( hba_cxy , hba_ptr + HBA_PXCI_REG ) , 1<<cmd_id );
+
+            ioc_dmsg("INFO in %s : thread %x / buffer = %llx at cycle %d\n",
+            __FUNCTION__ , hal_remote_lw( XPTR( th_cxy , &th_ptr->trdid ) ) ,
+            buf_xp , hal_time_stamp() );
+
+            // exit the while 
+            break;
+        }
+        else   // deschedule if no slot available in SOCLIB_HBA
+        {
+            sched_yield();
+        }
+    }  // end while
+            
+} // end soclib_hba_cmd()
+
+
+////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_hba_isr( device_t * dev )
+{
+    // get extended pointer on client thread
+    xptr_t root      = XPTR( local_cxy , &dev->wait_root );
+    xptr_t client_xp = XLIST_FIRST_ELEMENT( root , thread_t , wait_list );
+
+    // get client thread cluster and local pointer
+    cxy_t      client_cxy = GET_CXY( client_xp );
+    thread_t * client_ptr = (thread_t *)GET_PTR( client_xp );
+
+    // get SOCLIB_HBA device cluster and local pointer
+    cxy_t      hba_cxy  = GET_CXY( dev->base );
+    uint32_t * hba_ptr  = (uint32_t *)GET_PTR( dev->base );
+
+    // get HBA_PXIS_REG and HBA_PXIS_REG current values
+    uint32_t current_pxis = hal_remote_lw( XPTR( hba_cxy , hba_ptr + HBA_PXIS_REG ) );
+    uint32_t current_pxci = hal_remote_lw( XPTR( hba_cxy , hba_ptr + HBA_PXCI_REG ) );
+
+    uint32_t  error    = (current_pxis & 0x40000000) >> 30;
+    uint32_t  fault_id = (current_pxis & 0x1F000000) >> 24;
+    uint32_t  iter;
+
+    // loop on active commands to signal one or several completed I/O operations
+    for( iter = 0 ; iter < 32 ; iter++ )
+    {
+        if ( ( (hba_active_slots & (1<<iter)) != 0 ) &&  // active command
+             ( (current_pxci     & (1<<iter)) == 0 ) )   // completed command
+        {
+            // release the slot
+            hba_active_slots &= ~(1<<iter);
+
+            // set operation status in client thread command
+            if( error && (iter == fault_id ) ) 
+            {
+                hal_remote_sw( XPTR( client_cxy , &client_ptr->dev.ioc.error ) , 1 );
+            }
+            else
+            {
+                hal_remote_sw( XPTR( client_cxy , &client_ptr->dev.ioc.error ) , 0 );
+            }
+
+            // unblock client thread
+            thread_unblock( client_xp , THREAD_BLOCKED_IO );
+ 
+            ioc_dmsg("INFO in %s : thread %x at cycle %d\n",
+            __FUNCTION__ , hal_remote_lw( XPTR( client_cxy , &client_ptr->trdid ) ) ,
+            hal_time_stamp() );
+        }
+    }
+
+    // reset HBA_PXIS_REG
+    hal_remote_sw( XPTR( hba_cxy , hba_ptr + HBA_PXIS_REG ) , 0 );
+
+} // end soclib_hba_isr()
+
+
+
Index: trunk/kernel/drivers/soclib/soclib_hba.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_hba.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_hba.h	(revision 1)
@@ -0,0 +1,160 @@
+/*
+ * soclib_hba.h - soclib AHCI block device driver definition.
+ *
+ * Author        Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_HBA_H_
+#define _SOCLIB_HBA_H_
+
+#include <device.h>
+#include <hal_types.h>
+
+/*****************************************************************************************
+ * This driver supports the SocLib VciMultiAhci component, that is a multi-channels,
+ * block oriented, external storage controler, respecting the AHCI standard.
+ *
+ * 1. Each HBA channel define an independant physical disk, but this driver
+ *    supports only channel 0, because ALMOS-MKH uses only one physical disk.
+ *
+ * 2. The SOCLIB HBA component support split memory buffers (several physical
+ *    buffers for one single command), but this driver supports only one
+ *    single buffer I/O operation.
+ *
+ * 3. The "command list" can register up to 32 independant commands, posted
+ *    by different user threads. The command list is filled by the server
+ *    thread associated to the device, using one free slot per command, until the
+ *    device waiting queue of client threads is empty.
+ *
+ * 4. As there is only one interrupt, and the registered I/O operation can complete
+ *    in any order, this interrupt is not linked to a specific I/O operation.
+ *    The associated HBA_ISR unblock all client threads that have a completed command,
+ *    using the "hba_active_slots" and "hba_owner_thread[32]" global variables.
+ ****************************************************************************************/
+
+/*****************************************************************************************
+ * HBA component registers offsets
+ ****************************************************************************************/
+
+enum SoclibMultiAhciRegisters 
+{
+  HBA_PXCLB_REG        = 0,         // command list base address 32 LSB bits
+  HBA_PXCLBU_REG       = 1,         // command list base address 32 MSB bits
+  HBA_PXIS_REG         = 4,         // interrupt status
+  HBA_PXIE_REG         = 5,         // interrupt enable
+  HBA_PXCMD_REG        = 6,         // run
+  HBA_BLOCK_SIZE_REG   = 7,         // number of bytes per block
+  HBA_BLOCK_COUNT_REG  = 8,         // number of blocks
+  HBA_PXCI_REG         = 14,        // command bit-vector     
+
+};
+
+/*****************************************************************************************
+ * This structure defines the command header  (16 bytes)
+ ****************************************************************************************/
+
+typedef struct hba_cmd_header_s  
+{
+    unsigned int        res0;       // reserved	
+    unsigned char	    lba0;	    // LBA 7:0
+    unsigned char	    lba1;	    // LBA 15:8
+    unsigned char	    lba2;	    // LBA 23:16
+    unsigned char	    res1;	    // reserved
+    unsigned char	    lba3;	    // LBA 31:24
+    unsigned char	    lba4;	    // LBA 39:32
+    unsigned char	    lba5;	    // LBA 47:40
+    unsigned char	    res2;	    // reserved
+    unsigned int        res3;       // reserved	
+
+} 
+hba_cmd_header_t;
+
+/*****************************************************************************************
+ * This structure defines the command buffer  (16 bytes)
+ ****************************************************************************************/
+
+typedef struct hba_cmd_buffer_s 
+{
+    unsigned int        dba;	    // Buffer base address 32 LSB bits
+    unsigned int        dbau;	    // Buffer base address 32 MSB bits
+    unsigned int        res0;	    // reserved
+    unsigned int        dbc;	    // Buffer byte count
+} 
+hba_cmd_buffer_t;
+
+/*****************************************************************************************
+ * This structure defines a command table  (32 bytes, because we support only one buffer)
+ ****************************************************************************************/
+
+typedef struct hba_cmd_table_s
+{
+    hba_cmd_header_t   header;      // contains LBA
+    hba_cmd_buffer_t   buffer;      // only one physical buffer
+}
+hba_cmd_table_t;
+
+/*****************************************************************************************
+ * This structure defines a command descriptor  (16 bytes)
+ ****************************************************************************************/
+
+typedef struct hba_cmd_desc_s
+{
+    unsigned char       flag[2];    // W in bit 6 of flag[0]
+    unsigned char       prdtl[2];	// Number of buffers
+    unsigned int        prdbc;		// Number of bytes actually transfered
+    unsigned int        ctba;		// Command Table base address 32 LSB bits
+    unsigned int        ctbau;		// Command Table base address 32 MSB bits
+}
+hba_cmd_desc_t;
+
+/********************************************************************************************
+ * This function access the SOCLIB_HBA hardware registers to get the block size and the
+ * number of blocks, and initialises the "extension" field of the IOC device descriptor.
+ ********************************************************************************************
+ * @ dev_xp     : extended pointer on the generic IOC device descriptor.
+ *******************************************************************************************/
+extern void soclib_hba_init( xptr_t dev_xp );
+
+/********************************************************************************************
+ * This function is called by the server thread associated to the IOC device.
+ * It decodes the IOC device command embedded in the calling thread descriptor,
+ * (format defined in the dev_ioc.h file) and starts execution of this generic command, 
+ * accessing the relevant SOCLIB_HBA hardware registers.
+ * It registers the command in the SOCLIB_HBA device and returns without blocking
+ * because this AHCI component supports up to 32 concurrent I/O operations. 
+ * It simply deschedules without blocking if the number of registered I/O operations
+ * becomes larger than 32, which should be a rare event.
+ ********************************************************************************************
+ * @ xp_thread  : extended pointer on the client thread.
+ *******************************************************************************************/
+extern void soclib_hba_command( xptr_t  thread_xp );
+
+/********************************************************************************************
+ * This Interrupt Service Routine is executed when the IRQ signaling the completion of 
+ * one or several I/O operations registered in the SOCLIB_AHCI device is received.
+ * It acknowledges the IRQ by accessing the proper SOCLIB_HBA register, and unblock
+ * all client thread that have an I/O operation completed.
+ ********************************************************************************************
+ * @ dev     : local pointer on the generic IOC device descriptor.
+ *******************************************************************************************/
+extern void soclib_hba_isr( device_t * dev );
+
+
+#endif /* _SOCLIB_HBA_H_ */
